"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _path = _interopRequireDefault(require("path"));
var _lockfile = _interopRequireDefault(require("lockfile"));
var _fs = require("fs");
function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }
function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }
function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }
var _getLockFilePath = /*#__PURE__*/new WeakSet();
var _createDirectoryIfNotExist = /*#__PURE__*/new WeakSet();
class FileMutex {
  constructor(directory, lockFileName, timeout) {
    _classPrivateMethodInitSpec(this, _createDirectoryIfNotExist);
    _classPrivateMethodInitSpec(this, _getLockFilePath);
    this.directory = directory;
    this.lockFileName = lockFileName;
    this.timeout = timeout;
  }
  async acquire() {
    _classPrivateMethodGet(this, _createDirectoryIfNotExist, _createDirectoryIfNotExist2).call(this);
    return new Promise((resolve, reject) => {
      _lockfile.default.lock(_classPrivateMethodGet(this, _getLockFilePath, _getLockFilePath2).call(this), this.timeout, err => {
        if (err) {
          reject(err);
        } else {
          resolve();
        }
      });
    });
  }
  async release() {
    return new Promise((resolve, reject) => {
      _lockfile.default.unlock(_classPrivateMethodGet(this, _getLockFilePath, _getLockFilePath2).call(this), err => {
        if (err) {
          reject(err);
        } else {
          resolve();
        }
      });
    });
  }
}
function _getLockFilePath2() {
  return _path.default.resolve(_path.default.join(this.directory, `/${this.lockFileName}.lock`));
}
function _createDirectoryIfNotExist2() {
  if (!(0, _fs.existsSync)(this.directory)) {
    (0, _fs.mkdirSync)(this.directory, {
      recursive: true
    });
  }
}
var _default = exports.default = FileMutex;